# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Node(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Node - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'profile': 'str',
            'name': 'str',
            'obm_settings': 'object',
            'ip_addresses': 'object',
            'workflows': 'list[Graphobject]',
            'catalogs': 'list[Catalog]',
            'sku': 'Sku'
        }

        self.attribute_map = {
            'id': 'id',
            'profile': 'profile',
            'name': 'name',
            'obm_settings': 'obmSettings',
            'ip_addresses': 'ipAddresses',
            'workflows': 'workflows',
            'catalogs': 'catalogs',
            'sku': 'sku'
        }

        self._id = None
        self._profile = None
        self._name = None
        self._obm_settings = None
        self._ip_addresses = None
        self._workflows = None
        self._catalogs = None
        self._sku = None

    @property
    def id(self):
        """
        Gets the id of this Node.


        :return: The id of this Node.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Node.


        :param id: The id of this Node.
        :type: str
        """
        self._id = id

    @property
    def profile(self):
        """
        Gets the profile of this Node.


        :return: The profile of this Node.
        :rtype: str
        """
        return self._profile

    @profile.setter
    def profile(self, profile):
        """
        Sets the profile of this Node.


        :param profile: The profile of this Node.
        :type: str
        """
        self._profile = profile

    @property
    def name(self):
        """
        Gets the name of this Node.


        :return: The name of this Node.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Node.


        :param name: The name of this Node.
        :type: str
        """
        self._name = name

    @property
    def obm_settings(self):
        """
        Gets the obm_settings of this Node.


        :return: The obm_settings of this Node.
        :rtype: object
        """
        return self._obm_settings

    @obm_settings.setter
    def obm_settings(self, obm_settings):
        """
        Sets the obm_settings of this Node.


        :param obm_settings: The obm_settings of this Node.
        :type: object
        """
        self._obm_settings = obm_settings

    @property
    def ip_addresses(self):
        """
        Gets the ip_addresses of this Node.


        :return: The ip_addresses of this Node.
        :rtype: object
        """
        return self._ip_addresses

    @ip_addresses.setter
    def ip_addresses(self, ip_addresses):
        """
        Sets the ip_addresses of this Node.


        :param ip_addresses: The ip_addresses of this Node.
        :type: object
        """
        self._ip_addresses = ip_addresses

    @property
    def workflows(self):
        """
        Gets the workflows of this Node.


        :return: The workflows of this Node.
        :rtype: list[Graphobject]
        """
        return self._workflows

    @workflows.setter
    def workflows(self, workflows):
        """
        Sets the workflows of this Node.


        :param workflows: The workflows of this Node.
        :type: list[Graphobject]
        """
        self._workflows = workflows

    @property
    def catalogs(self):
        """
        Gets the catalogs of this Node.


        :return: The catalogs of this Node.
        :rtype: list[Catalog]
        """
        return self._catalogs

    @catalogs.setter
    def catalogs(self, catalogs):
        """
        Sets the catalogs of this Node.


        :param catalogs: The catalogs of this Node.
        :type: list[Catalog]
        """
        self._catalogs = catalogs

    @property
    def sku(self):
        """
        Gets the sku of this Node.


        :return: The sku of this Node.
        :rtype: Sku
        """
        return self._sku

    @sku.setter
    def sku(self, sku):
        """
        Sets the sku of this Node.


        :param sku: The sku of this Node.
        :type: Sku
        """
        self._sku = sku

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

